﻿using System;
using System.Collections.Generic;
using System.IO;

namespace M_class
{
    class DataHolder
    {
        public List<double> _target = new List<double>();
        public List<int[]> _input = new List<int[]>();

        Dictionary<char, int> mclass = new Dictionary<char, int>() { { 'e', 1 }, { 'p', -1 } };
        Dictionary<char, int> capshape = new Dictionary<char, int>() { { 'b', 1 }, { 'c', 2 }, { 'f', 3 }, { 'k', 4 }, { 's', 5 }, { 'x', 6 } };
        Dictionary<char, int> capsurface = new Dictionary<char, int>() { { 'f', 1 }, { 'g', 2 }, { 's', 3 }, { 'y', 4 } };
        Dictionary<char, int> capcolor = new Dictionary<char, int>() { { 'b', 1 }, { 'c', 2 }, { 'e', 3 }, { 'g', 4 }, { 'n', 5 },
            { 'p', 6 }, { 'r', 7 }, { 'u', 8 }, { 'w', 9 }, { 'y', 10 } };
        Dictionary<char, int> bruises = new Dictionary<char, int>() { { 'f', 1 }, { 't', 2 } };
        Dictionary<char, int> odor = new Dictionary<char, int>() { {'a', 1 }, { 'c', 2 }, { 'f', 3 }, { 'l', 4 },
            { 'm', 5 }, { 'n', 6 }, { 'p', 7 }, { 's', 8 }, { 'y', 9 } };
        Dictionary<char, int> gillattachment = new Dictionary<char, int>() { { 'a', 1 }, { 'f', 2 } };
        Dictionary<char, int> gillspacing = new Dictionary<char, int>() { { 'c', 1 }, { 'w', 2 } };
        Dictionary<char, int> gillsize = new Dictionary<char, int>() { { 'b', 1 }, { 'n', 2 } };
        Dictionary<char, int> gillcolor = new Dictionary<char, int>() { { 'b', 1 }, { 'e', 2 }, { 'g', 3 },
            { 'h', 4 }, { 'k', 5 }, { 'n', 6 }, { 'o', 7 }, { 'p', 8 }, { 'r', 9 }, { 'u', 10 }, { 'w', 11 }, { 'y', 12 } };
        Dictionary<char, int> stalkshape = new Dictionary<char, int>() { { 'e', 1 }, { 't', 2 } };
        Dictionary<char, int> stalkroot = new Dictionary<char, int>() { { '?', 1 }, { 'b', 2 }, { 'c', 3 }, { 'e', 4 }, { 'r', 5 } };
        Dictionary<char, int> stalksurfaceabovering = new Dictionary<char, int>() { { 'f', 1 }, { 'k', 2 }, { 's', 3 }, { 'y', 4 } };
        Dictionary<char, int> stalksurfacebelowring = new Dictionary<char, int>() { { 'f', 1 }, { 'k', 2 }, { 's', 3 }, { 'y', 4 } };
        Dictionary<char, int> stalkcolorabovering = new Dictionary<char, int>() { { 'b', 1 }, { 'c', 2 }, { 'e', 3 },
            { 'g', 4 }, { 'n', 5 }, { 'o', 6 }, { 'p', 7 }, { 'w', 8 }, { 'y', 9 } };
        Dictionary<char, int> stalkcolorbelowring = new Dictionary<char,int>() { { 'b', 1 }, { 'c', 2 }, { 'e', 3 },
            { 'g', 4 }, { 'n', 5 }, { 'o', 6 }, { 'p', 7 }, { 'w', 8 }, { 'y', 9 } };
        Dictionary<char, int> veiltype = new Dictionary<char, int>() { { 'p', 1 } };
        Dictionary<char, int> veilcolor = new Dictionary<char, int>() { { 'n', 1 }, { 'o', 2 }, { 'w', 3 }, { 'y', 4 } };
        Dictionary<char, int> ringnumber = new Dictionary<char, int>() { { 'n', 1 }, { 'o', 2 }, { 't', 3 } };
        Dictionary<char, int> ringtype = new Dictionary<char, int>() { { 'e', 1 }, { 'f', 2 }, { 'l', 3 }, { 'n', 4 }, { 'p', 5 } };
        Dictionary<char, int> sporeprintcolor = new Dictionary<char, int>() { { 'b', 1 }, { 'h', 2 }, { 'k', 3 }, { 'n', 4 }, { 'o', 5 },
            { 'r', 6 }, { 'u', 7 }, { 'w', 8 }, { 'y', 9 } };
        Dictionary<char, int> population = new Dictionary<char, int>() { { 'a', 1 }, { 'c', 2 }, { 'n', 3 }, { 's', 4 }, { 'v', 5 }, { 'y', 6 } };
        Dictionary<char, int> habitat = new Dictionary<char, int>() { { 'd', 1 }, { 'g', 2 }, { 'l', 3 }, { 'm', 4 }, { 'p', 5 }, { 'u', 6 }, { 'w', 7 } };

        private void Shuffle()
        {
            int[] position = Static.Shuffle(_target.Count);

            List<double> tmp = new List<double>();
            for (int i = 0; i < _target.Count; ++i)
            {
                tmp.Add(_target[position[i]]);
            }
            _target.Clear();
            for (int i = 0; i < tmp.Count; ++i)
            {
                _target.Add(tmp[i]);
            }
            //
            List<int[]> tmpArr = new List<int[]>();
            for (int i = 0; i < _input.Count; ++i)
            {
                tmpArr.Add(_input[position[i]]);
            }
            _input.Clear();
            for (int i = 0; i < tmpArr.Count; ++i)
            {
                _input.Add(tmpArr[i]);
            }
        }

        public void ProcessDataFile(string fileName)
        {
            if (!File.Exists(fileName))
            {
                Console.WriteLine("File {0} not found", fileName);
                Environment.Exit(0);
            }

            using (StreamReader reader = new StreamReader(fileName))
            {
                string tmp = reader.ReadLine(); //skip first line

                while (true)
                {
                    string line = reader.ReadLine();
                    if (null == line) break;

                    string[] lines = line.Split(',');
                    _target.Add(mclass[Convert.ToChar(lines[0])]);
                    int[] data = new int[22];
                    data[0] = capshape[Convert.ToChar(lines[1])];
                    data[1] = capsurface[Convert.ToChar(lines[2])];
                    data[2] = capcolor[Convert.ToChar(lines[3])];
                    data[3] = bruises[Convert.ToChar(lines[4])];
                    data[4] = odor[Convert.ToChar(lines[5])];
                    data[5] = gillattachment[Convert.ToChar(lines[6])];
                    data[6] = gillspacing[Convert.ToChar(lines[7])];
                    data[7] = gillsize[Convert.ToChar(lines[8])];
                    data[8] = gillcolor[Convert.ToChar(lines[9])];
                    data[9] = stalkshape[Convert.ToChar(lines[10])];
                    data[10] = stalkroot[Convert.ToChar(lines[11])];
                    data[11] = stalksurfaceabovering[Convert.ToChar(lines[12])];
                    data[12] = stalksurfacebelowring[Convert.ToChar(lines[13])];
                    data[13] = stalkcolorabovering[Convert.ToChar(lines[14])];
                    data[14] = stalkcolorbelowring[Convert.ToChar(lines[15])];
                    data[15] = veiltype[Convert.ToChar(lines[16])];
                    data[16] = veilcolor[Convert.ToChar(lines[17])];
                    data[17] = ringnumber[Convert.ToChar(lines[18])];
                    data[18] = ringtype[Convert.ToChar(lines[19])];
                    data[19] = sporeprintcolor[Convert.ToChar(lines[20])];
                    data[20] = population[Convert.ToChar(lines[21])];
                    data[21] = habitat[Convert.ToChar(lines[22])];

                    _input.Add(data);
                }
            }
            Shuffle();
        }
    }
}
